#! /usr/bin/python
# coding: utf-8

key='*SSTIC-2015*'
source='1d87c4c4e0ee40383c59447f23798d9fefe74fb82480766e'.decode('hex')

def T0(key, octet, i):
    out=((2*ord(key[i])+i)^ord(octet))&0xff
    #i démarre de 0 et va jusqu'à 11
    a=T1(key)
    b=T2(key)
    c=T3(key)
    triple_xor=ord(a)^ord(b)^ord(c)
    ##trois lignes pour faire key[i]=a
    l=list(key)
    l[i]=chr(triple_xor)
    key=''.join(l)
    return out,key

def T1(key):
    #a priori OK
    a=ord(T4(key))
    b=ord(T5(key))
    c=ord(T6(key))
    temp=a^b^c
    return chr(temp)

global T4_var1
T4_var1=0

def T4(key):
    global T4_var1
    for var_0 in range(0,0xc):
        T4_var1=(T4_var1+ord(key[var_0]))&0xff
    return(chr(T4_var1))

global T5_var1
T5_var1=0

def T5(key):
    global T5_var1
    for var_0 in range(0,0xc):
        T5_var1=ord(key[var_0])^T5_var1
    return(chr(T5_var1))

global T6_var3
global T6_var1
T6_var3=0
T6_var1=0

def T6(key):
    global T6_var3
    global T6_var1
    if T6_var3==0:
        for var_0 in range(0,0xc):
            #la clé ne sert qu'une fois??
            T6_var1=(ord(key[var_0])+T6_var1) & 0xffff
        T6_var3=1
    R=((T6_var1&0x8000)>>0xf)^((T6_var1&0x4000)>>0xe)
    Z=((T6_var1<<1)^R)&0xffff
    T6_var1=Z
    return(chr(Z&0xff))

def T2(key):
    a=ord(T7(key))
    b=ord(T8(key))
    c=ord(T9(key))
    temp=a^b^c
    return chr(temp)

def T7(key):
    #OK avec ca
    var_0=0
    var_1=0
    #c'est bien un range jusqu'a 6
    for i in range(0,6):
        var_0=(var_0+ord(key[i]))&0xff
        var_1=(var_1+ord(key[i+6]))&0xff
    return(chr(var_0^var_1))

global T8_var4
T8_var4=0
global T8_clef
T8_clef='\x00'*48

def T8(key):
    global T8_var4
    global T8_clef
    #la clé ne démarre pas à key[0], mais à T8_var4*3
    start=T8_var4*3*4
    l_T8_clef=list(T8_clef)
    for i in range(0,0xc):
        l_T8_clef[start+i]=key[i]
    T8_clef=''.join(l_T8_clef)
    T8_var4=(T8_var4+1)%4
    var_3=0
    for var_2 in range(0,4):
        var_1=0
        for var_0 in range(0,0xc):
            var_1=(ord(T8_clef[var_2*4*3+var_0])+var_1)&0xff
        var_3=(var_1^var_3)&0xff
    return chr(var_3)

def T9(key):
    T9_var1=0
    for i in range(0,12):
        byte=ord(key[i])<<(7&i)
        T9_var1=(T9_var1^byte)&0xff
    return chr(T9_var1)

def T3(key):
    a=ord(T10(key))
    #T11 et T12 communiquent entre eux
    T12_in,val_c=T12(key)
    c=ord(val_c)
    b=ord(T11(key,T12_in))
    temp=a^b^c
    return chr(temp)

global T10_var2
T10_var2=0
global T10_key
T10_key='\x00'*48

def T10(key):
    global T10_var2
    global T10_key
    #la clé est copiée à T_10key[T10_var2*3] en wsub
    start=T10_var2*3*4
    l_T10_key=list(T10_key)
    for i in range(0,0xc):
        l_T10_key[start+i]=key[i]
    T10_key=''.join(l_T10_key)
    T10_var2=(T10_var2+1)%4
    var_1=0
    for var_0 in range(0,4):
        var_1=(ord(T10_key[((var_0*3)*4)])+var_1)&0xff
    A=T10_key[((var_1&3)*3*4)+((var_1>>4)%0xc)]
    return A

def T11(key,T12_in):
    #T11 fait un ord(key[0])^ord(key[3])^ord(key[7]) et envoie à T12
    #A priori, pas de changement ni de stockage de l'info
    #Le byte reçu de T12 donne le rang modulo 12 de l'octet à renvoyer
    return key[T12_in%0xc]

global T12_key
T12_key='\x00'*12

def T12(key):
    global T12_key
    #Operation faite par T11
    T11_in=ord(key[0])^ord(key[3])^ord(key[7])
    var_1=ord(T12_key[1])^ord(T12_key[5])^ord(T12_key[9])
    T12_key=key
    return var_1,key[T11_in%0xc]

####### MAIN #######
sortie=[]
K=key
for i in range(0,len(source)):
    #if i%12 == 0:
    #    K=key
    c,K=T0(K,source[i],i%12)
    sortie.append(c)
    
print ''.join([chr(i) for i in sortie])
